//Robo Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//Information of one play
//
public class ReplayInfo extends Observable{

	static protected String	teamName[] = new String[2];
	protected	int	score[] = new int[2];
	protected 	int 	time;
	protected 	String	pmode; 

	protected	double minBallDist;

	protected 	CPlayer[] player = new CPlayer[22];
	protected 	CBall cball;	

	protected 	boolean kicked;	
		
	protected	int kickMember;
	protected	int kickX, kickY;


	//protected   ReplayInfo before;

	ReplayInfo(){
			
		for(int i = 0; i < 2; ++i){
			teamName[i] = new String();
		} 
		   
		cball = new CBall(this);

		for (int i = 0; i <= 21; ++i){
			player[i] = new CPlayer(this);
		}			
	}

	//֥СΤ򤹤
	public void changes(){

		setChanged();
		notifyObservers();
	}

	String getTeamName(int side){

		int si = (side == CParam.CType_LEFT)? 0 : 1;

		return teamName[si].trim(); 

	}

	 CBall getCBall(){

		return cball;
	}
	
	
	int getScore(int side){

	    int si = (side == CParam.CType_LEFT)? 0 : 1; 

	    return score[si]; 
	}

	int getTime(){
		return time;	
	}
	
	String getPlayMode(){
		return pmode;
	}

	int getPlayerDistance(int index){
		return player[index].getDistance();
	}

	int getTeamDistance(int side){
		int total = 0;
		int base = (side == CParam.CType_LEFT)? 0 : 11;

		for(int i = 0; i <= 10; ++i){
			total = total += player[base + i].getDistance();			
		}
		return total;
	}
		
	void drawAll(Graphics g){

		for (int i = 0; i <= 21; ++i){
			player[i].drawPlayer(g);
		}	
		
		cball.drawBall(g);
	}
	
	

	void drawAll(int time, Graphics g){

		for (int i = 0; i <= 21; ++i){
			player[i].drawPlayer(time, g);
		}	
		
		cball.drawBall(time, g);
	}




	//Team̾򥻥åȤ
	void setTeamName(int teamSide, String teamName){

		//ꤷźϰǤ뤫ɤ
		if ((teamSide > 1) || (teamSide < 0)){
			System.out.println(teamSide+"ReplayInfo饹setTeamName᥽åɤϤͤ۾Ǥ");
			}

		this.teamName[teamSide]  = teamName; 

	}

	void setCBall(int x, int y){

		cball.set(x, y);
	}

	void setPlayer(int index, int x, int y, int angle, int side, int unum, Color c, int enable){

		//⤷,ץ졼䡼åȽꤵ줿ν
	    player[index].set(x, y, angle, side, unum, c,enable, time);
	}
		

	void setTime(int time){

		this.time = time;
	}
	
	void setPlayMode(String pmode){

		this.pmode = pmode; 
	}

	void setScore(int teamSide, int teamScore){

		score[teamSide] = teamScore;

	}
		
}




