//Robo Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//ʬϰϤꤹ
//
public class SetTimeDialog extends Dialog implements
			Runnable, ActionListener{
	
	MainWindow mw;
	
	Panel bottomPanel;
	Panel upperPanel;

	Button btnOK;
	Button btnCancel;

	TextField startText;
	TextField endText;

	//ɽ
	protected int startTime = CParam.START_TIME;
	protected int endTime = CParam.END_TIME;

	SetTimeDialog(MainWindow mw, boolean modal){

		super(mw, modal);

		this.mw = mw;
				
		setLayout(new BorderLayout(10,10));

		createUpperPanel();

		createBottomPanel();		

		setLocation(new Point(150,300));
		setSize(150, 200);
		setResizable(false);
	}


	protected void createBottomPanel(){

		btnOK = new Button("OK");
		btnCancel  = new Button("Cancel");

		bottomPanel = new Panel();

		bottomPanel.setLayout(new GridLayout(1, 2));

		bottomPanel.add(btnOK);
		bottomPanel.add(btnCancel);
	
		add("South", bottomPanel);

		btnOK.addActionListener(this);
		btnCancel.addActionListener(this);

	}

	protected void createUpperPanel(){
	
		upperPanel = new Panel();	

		upperPanel.setLayout(new GridLayout(2, 2, 10, 10));

		Label startLabel = new Label("start", Label.RIGHT);
		Label endLabel = new Label("end", Label.RIGHT);

		startText = new TextField(String.valueOf(startTime));
		endText = new TextField(String.valueOf(endTime));
			
		upperPanel.add(startLabel);
		upperPanel.add(startText);
		upperPanel.add(endLabel);
		upperPanel.add(endText);
		
		add("Center", upperPanel);
	}
	
	public void open(){
		Thread thread = new Thread(this);
		thread.start();
	}

	public void run(){

		setVisible(true);
	}

	public void actionPerformed(ActionEvent e){

		Object source = e.getSource();

		if (source == btnOK){
	
			System.out.println("OK");	

			try{
										
				startTime = Integer.valueOf(startText.getText().trim()).intValue();
				endTime   = Integer.valueOf(endText.getText().trim()).intValue();

			}catch(NumberFormatException nfe){
				
				startText.setText("");
				endText.setText("");
		
				return;			
			}

			System.out.println("start"+startTime);
			System.out.println("end"+endTime);

			BufferedReplay br;
			
			br = (BufferedReplay)mw.getReplay();

			br.startAnalyze(startTime, endTime);

			setVisible(false);	

			dispose();

		}
		
		else if (source == btnCancel){

			setVisible(false);

			dispose();
		
		}

		


	}

}

	
